"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _classnames6 = _interopRequireDefault(require("classnames"));

var _reactCodemirror = _interopRequireDefault(require("@uiw/react-codemirror"));

var _copyToClipboard = _interopRequireDefault(require("@uiw/copy-to-clipboard"));

var _uiw = require("uiw");

var _icon = _interopRequireDefault(require("./icon"));

var _transform = require("./transform");

var CodePreview =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2.default)(CodePreview, _React$PureComponent);

  function CodePreview(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CodePreview);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(CodePreview).call(this, props));
    _this.demoDom = _react.default.createRef();
    _this.editor = _react.default.createRef();
    _this.initHeight = 3;
    _this.playerId = "".concat(parseInt(String(Math.random() * 1e9), 10).toString(36));
    _this.state = {
      errorMessage: '',
      fullScreen: false,
      copied: false,
      showEdit: false,
      width: 1
    };
    return _this;
  }

  (0, _createClass2.default)(CodePreview, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.props.noPreview) {
        this.executeCode(this.props.code);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.noPreview !== this.props.noPreview) {
        this.executeCode(this.props.code);
      }
    }
  }, {
    key: "executeCode",
    value: function () {
      var _executeCode = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(codeStr) {
        var args, argv, Elm, _key, input, _ref, code, message;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                args = ['context', 'React', 'ReactDOM', 'Component'];
                argv = [this, _react.default, _reactDom.default, _react.Component];
                Elm = this.props.dependencies;

                for (_key in Elm) {
                  args.push(_key);
                  argv.push(Elm[_key]);
                }

                codeStr = codeStr.replace('_mount_', "document.getElementById('".concat(this.playerId, "')"));
                input = "".concat(codeStr);
                _context.next = 9;
                return (0, _transform.BabelTransform)(input);

              case 9:
                _ref = _context.sent;
                code = _ref.code;
                args.push(code);
                (0, _construct2.default)(Function, args).apply(null, argv);
                this.setState({
                  errorMessage: ''
                });
                _context.next = 21;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](0);
                message = '';

                if (_context.t0 && _context.t0.message) {
                  message = _context.t0.message;
                } else {
                  message = JSON.stringify(_context.t0);
                }

                this.setState({
                  errorMessage: message
                });

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 16]]);
      }));

      function executeCode(_x) {
        return _executeCode.apply(this, arguments);
      }

      return executeCode;
    }()
    /**
     * onCopyCode
     */

  }, {
    key: "onCopyCode",
    value: function onCopyCode() {
      var _this2 = this;

      var code = this.props.code;
      (0, _copyToClipboard.default)(code || '', function (isCopy) {
        _this2.setState({
          copied: isCopy
        });
      });
      setTimeout(function () {
        _this2.setState({
          copied: false
        });
      }, 2000);
    }
    /**
     * onFullScreen
     */

  }, {
    key: "onFullScreen",
    value: function onFullScreen() {
      var _this3 = this;

      var fullScreen = this.state.fullScreen;
      this.setState({
        fullScreen: !fullScreen
      }, function () {
        document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

        if (!fullScreen && _this3.demoDom.current) {
          _this3.demoDom.current.style.maxWidth = 'inherit';
        }
      });
    }
  }, {
    key: "initOldHeight",
    value: function initOldHeight() {
      var demo = this.demoDom.current;

      if (this.initHeight === 3 && demo) {
        this.initHeight = demo.clientHeight;
      }
    }
    /**
     * onSwitchSource
     */

  }, {
    key: "onSwitchSource",
    value: function onSwitchSource() {
      var _this4 = this;

      var width = this.state.width;
      this.initOldHeight();
      this.setState({
        width: width === 1 ? '50%' : 1,
        showEdit: true
      }, function () {
        var editor = _this4.editor.current;

        if (editor) {
          editor.editor.setSize('100%', width !== 1 ? _this4.initHeight : '100%');
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames,
          _classnames2,
          _this5 = this;

      var _this$props = this.props,
          style = _this$props.style,
          prefixCls = _this$props.prefixCls,
          className = _this$props.className,
          code = _this$props.code,
          dependencies = _this$props.dependencies,
          bordered = _this$props.bordered,
          noCode = _this$props.noCode,
          noPreview = _this$props.noPreview,
          noScroll = _this$props.noScroll,
          bgWhite = _this$props.bgWhite,
          otherProps = (0, _objectWithoutProperties2.default)(_this$props, ["style", "prefixCls", "className", "code", "dependencies", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"]);
      var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
      var visiable = this.state.width === 1 ? false : [isOneItem ? 1 : 2];
      return _react.default.createElement(_uiw.Split, (0, _extends2.default)({
        visiable: visiable,
        className: (0, _classnames6.default)(className, prefixCls, (_classnames = {}, (0, _defineProperty2.default)(_classnames, "".concat(prefixCls, "-noScroll"), noScroll), (0, _defineProperty2.default)(_classnames, "".concat(prefixCls, "-OneItem"), isOneItem), (0, _defineProperty2.default)(_classnames, "".concat(prefixCls, "-bordered"), bordered), (0, _defineProperty2.default)(_classnames, "".concat(prefixCls, "-fullScreen"), this.state.fullScreen), _classnames)),
        style: (0, _objectSpread2.default)({
          flex: 1
        }, style)
      }, otherProps), !noPreview && _react.default.createElement("div", {
        ref: this.demoDom,
        className: (0, _classnames6.default)("".concat(prefixCls, "-demo"), (_classnames2 = {}, (0, _defineProperty2.default)(_classnames2, "".concat(prefixCls, "-demo-bgPlaid"), !bgWhite), (0, _defineProperty2.default)(_classnames2, "".concat(prefixCls, "-demo-error"), this.state.errorMessage), _classnames2)),
        style: (0, _objectSpread2.default)({
          flex: 1
        }, this.state.width === 1 ? {
          width: '100%'
        } : {})
      }, this.state.errorMessage && _react.default.createElement("pre", null, _react.default.createElement("code", null, this.state.errorMessage)), _react.default.createElement("div", {
        className: (0, _classnames6.default)("".concat(prefixCls, "-demo-source"), (0, _defineProperty2.default)({}, 'error', this.state.errorMessage)),
        id: this.playerId
      })), !noCode && _react.default.createElement("div", {
        style: {
          overflow: 'hidden',
          width: this.state.width
        }
      }, this.state.showEdit && _react.default.createElement(_reactCodemirror.default, {
        value: code,
        ref: this.editor,
        onChange: function onChange(editor) {
          _this5.executeCode(editor.getValue());
        },
        options: {
          theme: 'monokai',
          mode: 'jsx'
        }
      })), !isOneItem && !(noCode && noPreview) && _react.default.createElement("div", {
        style: {
          flex: 1,
          width: 29
        },
        className: "".concat(prefixCls, "-bar")
      }, _react.default.createElement("div", {
        className: "".concat(prefixCls, "-bar-btn"),
        onClick: this.onSwitchSource.bind(this)
      }, this.state.width === 1 ? '源码' : '隐藏编辑器'), _react.default.createElement("div", {
        className: (0, _classnames6.default)("".concat(prefixCls, "-bar-iconbtns"), (0, _defineProperty2.default)({}, "".concat(prefixCls, "-bar-copied"), this.state.copied)),
        onClick: this.onCopyCode.bind(this)
      }, _icon.default.copy), _react.default.createElement("div", {
        className: (0, _classnames6.default)("".concat(prefixCls, "-bar-iconbtns"), (0, _defineProperty2.default)({}, "".concat(prefixCls, "-bar-copied"), this.state.fullScreen)),
        onClick: this.onFullScreen.bind(this)
      }, _icon.default.full)));
    }
  }]);
  return CodePreview;
}(_react.default.PureComponent);

exports.default = CodePreview;
CodePreview.defaultProps = {
  prefixCls: 'w-code-preview',
  code: '',
  noCode: false,
  bgWhite: false,
  noPreview: false,
  bordered: true
}; 
//# sourceMappingURL=index.js.map