import _extends from "@babel/runtime/helpers/esm/extends";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _construct from "@babel/runtime/helpers/esm/construct";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import classnames from 'classnames';
import CodeMirror from '@uiw/react-codemirror';
import copyTextToClipboard from '@uiw/copy-to-clipboard';
import { Split } from 'uiw';
import icon from './icon';
import { BabelTransform } from './transform';
import './monokai.css';
import "./index.css";

var CodePreview =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CodePreview, _React$PureComponent);

  function CodePreview(props) {
    var _this;

    _classCallCheck(this, CodePreview);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CodePreview).call(this, props));
    _this.demoDom = React.createRef();
    _this.editor = React.createRef();
    _this.initHeight = 3;
    _this.playerId = "".concat(parseInt(String(Math.random() * 1e9), 10).toString(36));
    _this.state = {
      errorMessage: '',
      fullScreen: false,
      copied: false,
      showEdit: false,
      width: 1
    };
    return _this;
  }

  _createClass(CodePreview, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.props.noPreview) {
        this.executeCode(this.props.code);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.noPreview !== this.props.noPreview) {
        this.executeCode(this.props.code);
      }
    }
  }, {
    key: "executeCode",
    value: function () {
      var _executeCode = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee(codeStr) {
        var args, argv, Elm, _key, input, _ref, code, message;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                args = ['context', 'React', 'ReactDOM', 'Component'];
                argv = [this, React, ReactDOM, Component];
                Elm = this.props.dependencies;

                for (_key in Elm) {
                  args.push(_key);
                  argv.push(Elm[_key]);
                }

                codeStr = codeStr.replace('_mount_', "document.getElementById('".concat(this.playerId, "')"));
                input = "".concat(codeStr);
                _context.next = 9;
                return BabelTransform(input);

              case 9:
                _ref = _context.sent;
                code = _ref.code;
                args.push(code);

                _construct(Function, args).apply(null, argv);

                this.setState({
                  errorMessage: ''
                });
                _context.next = 21;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](0);
                message = '';

                if (_context.t0 && _context.t0.message) {
                  message = _context.t0.message;
                } else {
                  message = JSON.stringify(_context.t0);
                }

                this.setState({
                  errorMessage: message
                });

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 16]]);
      }));

      function executeCode(_x) {
        return _executeCode.apply(this, arguments);
      }

      return executeCode;
    }()
    /**
     * onCopyCode
     */

  }, {
    key: "onCopyCode",
    value: function onCopyCode() {
      var _this2 = this;

      var code = this.props.code;
      copyTextToClipboard(code || '', function (isCopy) {
        _this2.setState({
          copied: isCopy
        });
      });
      setTimeout(function () {
        _this2.setState({
          copied: false
        });
      }, 2000);
    }
    /**
     * onFullScreen
     */

  }, {
    key: "onFullScreen",
    value: function onFullScreen() {
      var _this3 = this;

      var fullScreen = this.state.fullScreen;
      this.setState({
        fullScreen: !fullScreen
      }, function () {
        document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

        if (!fullScreen && _this3.demoDom.current) {
          _this3.demoDom.current.style.maxWidth = 'inherit';
        }
      });
    }
  }, {
    key: "initOldHeight",
    value: function initOldHeight() {
      var demo = this.demoDom.current;

      if (this.initHeight === 3 && demo) {
        this.initHeight = demo.clientHeight;
      }
    }
    /**
     * onSwitchSource
     */

  }, {
    key: "onSwitchSource",
    value: function onSwitchSource() {
      var _this4 = this;

      var width = this.state.width;
      this.initOldHeight();
      this.setState({
        width: width === 1 ? '50%' : 1,
        showEdit: true
      }, function () {
        var editor = _this4.editor.current;

        if (editor) {
          editor.editor.setSize('100%', width !== 1 ? _this4.initHeight : '100%');
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames,
          _classnames2,
          _this5 = this;

      var _this$props = this.props,
          style = _this$props.style,
          prefixCls = _this$props.prefixCls,
          className = _this$props.className,
          code = _this$props.code,
          dependencies = _this$props.dependencies,
          bordered = _this$props.bordered,
          noCode = _this$props.noCode,
          noPreview = _this$props.noPreview,
          noScroll = _this$props.noScroll,
          bgWhite = _this$props.bgWhite,
          otherProps = _objectWithoutProperties(_this$props, ["style", "prefixCls", "className", "code", "dependencies", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"]);

      var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
      var visiable = this.state.width === 1 ? false : [isOneItem ? 1 : 2];
      return React.createElement(Split, _extends({
        visiable: visiable,
        className: classnames(className, prefixCls, (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-noScroll"), noScroll), _defineProperty(_classnames, "".concat(prefixCls, "-OneItem"), isOneItem), _defineProperty(_classnames, "".concat(prefixCls, "-bordered"), bordered), _defineProperty(_classnames, "".concat(prefixCls, "-fullScreen"), this.state.fullScreen), _classnames)),
        style: _objectSpread({
          flex: 1
        }, style)
      }, otherProps), !noPreview && React.createElement("div", {
        ref: this.demoDom,
        className: classnames("".concat(prefixCls, "-demo"), (_classnames2 = {}, _defineProperty(_classnames2, "".concat(prefixCls, "-demo-bgPlaid"), !bgWhite), _defineProperty(_classnames2, "".concat(prefixCls, "-demo-error"), this.state.errorMessage), _classnames2)),
        style: _objectSpread({
          flex: 1
        }, this.state.width === 1 ? {
          width: '100%'
        } : {})
      }, this.state.errorMessage && React.createElement("pre", null, React.createElement("code", null, this.state.errorMessage)), React.createElement("div", {
        className: classnames("".concat(prefixCls, "-demo-source"), _defineProperty({}, 'error', this.state.errorMessage)),
        id: this.playerId
      })), !noCode && React.createElement("div", {
        style: {
          overflow: 'hidden',
          width: this.state.width
        }
      }, this.state.showEdit && React.createElement(CodeMirror, {
        value: code,
        ref: this.editor,
        onChange: function onChange(editor) {
          _this5.executeCode(editor.getValue());
        },
        options: {
          theme: 'monokai',
          mode: 'jsx'
        }
      })), !isOneItem && !(noCode && noPreview) && React.createElement("div", {
        style: {
          flex: 1,
          width: 29
        },
        className: "".concat(prefixCls, "-bar")
      }, React.createElement("div", {
        className: "".concat(prefixCls, "-bar-btn"),
        onClick: this.onSwitchSource.bind(this)
      }, this.state.width === 1 ? '源码' : '隐藏编辑器'), React.createElement("div", {
        className: classnames("".concat(prefixCls, "-bar-iconbtns"), _defineProperty({}, "".concat(prefixCls, "-bar-copied"), this.state.copied)),
        onClick: this.onCopyCode.bind(this)
      }, icon.copy), React.createElement("div", {
        className: classnames("".concat(prefixCls, "-bar-iconbtns"), _defineProperty({}, "".concat(prefixCls, "-bar-copied"), this.state.fullScreen)),
        onClick: this.onFullScreen.bind(this)
      }, icon.full)));
    }
  }]);

  return CodePreview;
}(React.PureComponent);

CodePreview.defaultProps = {
  prefixCls: 'w-code-preview',
  code: '',
  noCode: false,
  bgWhite: false,
  noPreview: false,
  bordered: true
};
export { CodePreview as default }; 
//# sourceMappingURL=index.js.map